SystemOrganization addCategory: #ConfigurationOfSmalltalkKoans!

Object subclass: #ConfigurationOfSmalltalkKoans
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSmalltalkKoans'!

!ConfigurationOfSmalltalkKoans class methodsFor: 'development support' stamp: 'pre 12/12/2011 17:23:31.808'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'private' stamp: 'pre 12/12/2011 17:23:31.822'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'private' stamp: 'pre 12/12/2011 17:23:31.828'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'private' stamp: 'pre 12/12/2011 17:23:31.834'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'metacello tool support' stamp: 'pre 12/12/2011 17:23:31.844'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'loading' stamp: 'pre 12/12/2011 17:23:31.85'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'loading' stamp: 'pre 12/12/2011 17:23:31.856'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'loading' stamp: 'pre 12/12/2011 17:23:31.862'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'accessing' stamp: 'pre 12/12/2011 17:23:31.868'!
project

	^self new project! !

!ConfigurationOfSmalltalkKoans class methodsFor: 'development support' stamp: 'pre 12/12/2011 17:23:31.816'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfSmalltalkKoans methodsFor: 'baselines' stamp: 'mp 10/21/2013 17:08'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/Koans'.
		spec 
			package: 'SUnit';
			package: 'Koans'.
		spec group: 'default' with: #('Koans' ). ].
! !

!ConfigurationOfSmalltalkKoans methodsFor: 'symbolic versions' stamp: 'wm 10/30/2013 12:16'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.1'.
! !

!ConfigurationOfSmalltalkKoans methodsFor: 'accessing' stamp: 'pre 12/12/2011 17:23:31.8'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSmalltalkKoans methodsFor: 'symbolic versions' stamp: 'wm 10/30/2013 12:16'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '1.1'.! !

!ConfigurationOfSmalltalkKoans methodsFor: 'versions' stamp: 'mp 10/21/2013 17:09'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Release version for Koans tutorial'.
		spec author: 'mp'.
		spec timestamp: '10/21/2013 17:04'.
		spec 
			package: 'SUnit' with: 'SUnit-mp.92';
			package: 'Koans' with: 'Koans-mp.41'. ].
! !

!ConfigurationOfSmalltalkKoans methodsFor: 'versions' stamp: 'wm 10/30/2013 12:19'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'release'.
		spec description: 'Improved UI'.
		spec author: 'wm'.
		spec timestamp: '10/30/2013 12:16'.
		spec 
			package: 'SUnit' with: 'SUnit-mp.92';
			package: 'Koans' with: 'Koans-wm.43'. ].! !
